medialibrary/urls.py
# Presenter Club - Make Great Presentations, Faster
# Copyright (C) 2016 Sam Parkinson <sam@sam.today>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

from django.conf.urls import url

from . import views

app_name = 'medialibrary'
urlpatterns = [
    url(r'^$', views.index, name='index'),
    url(r'^api/$', views.api_index, name='api_index'),
]

presenterclub/urls.py
# Presenter Club - Make Great Presentations, Faster
# Copyright (C) 2016 Sam Parkinson <sam@sam.today>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

from django.conf.urls.static import static
from django.conf.urls import url, include
from django.conf import settings
from django.contrib import admin

urlpatterns = [
    url(r'^admin/', admin.site.urls),
    url('^accounts/', include('django.contrib.auth.urls')),
    url('', include('promo.urls')),
    url(r'^u/(?P<username>.+)/medialibrary/', include('medialibrary.urls')),
    url(r'^u/(?P<username>.+)/styles/', include('styles.urls')),
    url(r'^u/', include('u.urls')),
    url(r'^imagesearch/', include('imagesearch.urls')),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

promo/urls.py
# Presenter Club - Make Great Presentations, Faster
# Copyright (C) 2016 Sam Parkinson <sam@sam.today>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

from django.conf.urls import url
from django.views.generic import TemplateView

from . import views

app_name = 'promo'
urlpatterns = [
    url(r'^$', views.index, name='index'),
    url(r'^signup$', views.signup, name='signup'),
    url(r'^signup/choose-plan$', views.choose_plan, name='chooseplan'),
    url(r'^go-pro$', views.go_pro, name='gopro'),
    url(r'^accounts/validateemail?token=(?P<token>.+)$',
        views.validate_email,
        name='validateemail'),
    url(r'^accounts/profile/$', views.accounts_profile),

    url(r'^terms$', TemplateView.as_view(template_name='promo/terms.html')),
    url(r'^plans$', TemplateView.as_view(template_name='promo/plans.html'),
        name='plans'),
]

styles/urls.py
# Presenter Club - Make Great Presentations, Faster
# Copyright (C) 2016 Sam Parkinson <sam@sam.today>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

from django.conf.urls import url

from . import views

app_name = 'styles'
urlpatterns = [
    url(r'^$', views.index, name='index'),
    url(r'^api$', views.api, name='api'),
    url(r'^create$', views.create, name='create'),
    url(r'^(?P<styleid>\d+)$', views.get, name='get'),
    url(r'^(?P<styleid>\d+)/edit$', views.edit, name='edit'),
    url(r'^(?P<styleid>\d+)/thumb.png$', views.thumb, name='thumb'),
    url(r'^(?P<styleid>\d+)/genthumb/(?P<key>.+)$',
        views.genthumb, name='genthumb'),
]

u/urls.py
# Presenter Club - Make Great Presentations, Faster
# Copyright (C) 2016 Sam Parkinson <sam@sam.today>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

from django.conf.urls import url

from . import views

app_name = 'u'
urlpatterns = [
    url(r'^$', views.index, name='index'),
    # Ex. /u/sam/
    url(r'^(?P<username>.+)/$', views.userpage, name='userpage'),
    url(r'^(?P<username>.+)/onboarding-status$', views.onboarding_status,
        name='onboardingstatus'),
    url(r'^(?P<username>.+)/create$', views.create, name='create'),
    url(r'^(?P<username>.+)/create.json$',
        views.create_json, name='createjson'),
    url(r'^(?P<username>.+)/settings/profile$',
        views.user_settings, name='usersettings'),
    url(r'^(?P<username>.+)/settings/plan$',
        views.user_plan, name='userplan'),
    url(r'^(?P<username>.+)/(?P<presentationid>.+)/view$',
        views.view, name='view'),
    url(r'^(?P<username>.+)/(?P<presentationid>.+)/view.json$',
        views.view_json, name='viewjson'),
    url(r'^(?P<username>.+)/(?P<presentationid>.+)/edit$',
        views.edit, name='edit'),
    url(r'^(?P<username>.+)/(?P<presentationid>.+)/delete$',
        views.delete_presentation, name='deletepresentation'),
    url(r'^(?P<username>.+)/(?P<presentationid>.+)/thumb.png$',
        views.thumb, name='thumb'),
    url(r'^(?P<username>.+)/(?P<presentationid>.+)/genthumb/(?P<key>.+)$',
        views.genthumb, name='genthumb'),
]

styles/models.py
# Presenter Club - Make Great Presentations, Faster
# Copyright (C) 2016 Sam Parkinson <sam@sam.today>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

import json
from django.db import models

from django.contrib.auth.models import User


DEFAULT_STYLE = 1  # Whatever


def thumb_directory_path(instance, filename):
    return 'style_thumbs/{0}/{1}.png'.format(
        instance.user.id, instance.id)


class Style(models.Model):
    user = models.ForeignKey(User, on_delete=models.DO_NOTHING)

    created_time = models.DateTimeField('Created', auto_now_add=True)
    edited_time = models.DateTimeField('Edited', auto_now=True)

    title = models.TextField('Title (publicly displayed)')
    data = models.TextField(default='{}')

    thumb = models.FileField(upload_to=thumb_directory_path, null=True)
    thumb_edited_time = models.DateTimeField(
        'When the thumbnail was last updated',
        null=True)

    def to_json(self):
        style = json.loads(self.data)
        return {
            'metadata': {
                'title': self.title
            },
            'style': style
        }

    designer = models.BooleanField(
        'is a designer style (public for all)',
        default=False)
    designer_order = models.IntegerField(
        'ordering for designer styles',
        default=1000)

styles/views.py
# Presenter Club - Make Great Presentations, Faster
# Copyright (C) 2016 Sam Parkinson <sam@sam.today>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

import json

from django.shortcuts import render, get_object_or_404
from django.core.exceptions import PermissionDenied
from django.core.urlresolvers import reverse
from django.http import HttpResponseRedirect, JsonResponse
from django.contrib.staticfiles.storage import staticfiles_storage

from u.decorators import personal_user_view
from u.models import UserProfile, is_pro_user
from u.views import json_escape
from styles.models import Style
from styles.tasks import generate_thumbnail, GENTHUMB_KEY

@personal_user_view
def index(request, user):
    styles = Style.objects.filter(user=user).order_by('-edited_time')
    return render(request, 'styles/index.html',
                  context={'styles': styles,
                           'is_pro': is_pro_user(user)})

def style_readonly_view(wrapping):
    puv = personal_user_view(wrapping)
    def f(request, username, styleid):
        s = get_object_or_404(Style, id=styleid)
        if s.designer or s.id == 1:
            return wrapping(request, username, s)
        else:
            return puv(request, username, s)
    return f

@personal_user_view
def api(request, user):
    def short_json(s):
        return {'id': s.id, 'user': s.user.username, 'title': s.title}
    mine = Style.objects.filter(user=user).order_by('-edited_time')
    j_mine = [short_json(s) for s in mine]
    designer = Style.objects.filter(designer=True).order_by('designer_order')
    j_designer = [short_json(s) for s in designer]
    return JsonResponse({'mine': j_mine, 'designer': j_designer})

@style_readonly_view
def get(request, username, s):
    return JsonResponse(s.to_json())

@personal_user_view
def create(request, user):
    s = Style(title='New Style', user=user)
    s.save()
    return HttpResponseRedirect(
        reverse('styles:edit', args=[user.username, s.id]))

@personal_user_view
def edit(request, user, styleid):
    s = get_object_or_404(Style, id=styleid)
    if s.user != request.user:
        raise PermissionDenied
    profile = get_object_or_404(UserProfile, user=s.user)

    if request.method == 'GET':
        json_string = json_escape(json.dumps(s.to_json()))
        return render(request, 'styles/app.html',
                      context={'style': s,
                               'profile': profile,
                               'json_string': json_string})
    else:
        j = json.loads(request.body.decode('utf8'))

        s.title = j['metadata']['title']
        s.data = json.dumps(j['style'])
        s.save()

        generate_thumbnail(s.id, request.get_host())

        return JsonResponse({'success': True})

def genthumb(request, username, styleid, key):
    if key != GENTHUMB_KEY:
        raise PermissionDenied

    s = get_object_or_404(Style, id=styleid)
    json_string = json_escape(json.dumps(s.to_json()))
    return render(request, 'styles/thumb.html',
                  context={'json_string': json_string})

@style_readonly_view
def thumb(request, username, s):
    if not s.thumb:
        return HttpResponseRedirect(
            staticfiles_storage.url('images/emptythumb.svg'))
    return HttpResponseRedirect(s.thumb.url)

styles/templates/styles/app.html
{% extends "base/normal.html" %}
{% comment %}
Presenter Club - Make Great Presentations, Faster
Copyright (C) 2016 Sam Parkinson <sam@sam.today>

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
{% endcomment %}
{% load render_bundle from webpack_loader %}

{% block title %}Edit {{ style.title }} on Presenter Club{% endblock title %}

{% block header %}
{% endblock header %}

{% block main %}
<div id="react-container">
    Loading {{ style.title }}...
</div>
{% endblock main %}

{% block end %}
    <script>
        {% include 'base/djangosUser.js' %}
        window.djangosGift = {{ json_string | safe }};
    </script>

    {% render_bundle 'style_edit' 'js' %}
{% endblock end %}

styles/templates/styles/index.html
{% extends "base/normal.html" %}

{% comment %}
Presenter Club - Make Great Presentations, Faster
Copyright (C) 2016 Sam Parkinson <sam@sam.today>

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
{% endcomment %}

{% block title %}{{ user.username }}'s Styles on Presenter Club{% endblock title %}

{% block content %}
<div class="title-n-button">
    <h1>Your Styles</h1>
</div>
<p></p>

<div class="Tabs">
    <div class="Tabs__head">
        <a class="Tabs__head__label"
           href="{% url 'medialibrary:index' username=user.username %}">
            Media Library
        </a>
        <a class="Tabs__head__label"
           href="{% url 'u:userpage' username=user.username %}">
            Presentations
        </a>
        <a class="Tabs__head__label Tabs__head__label--selected"
           href="{% url 'styles:index' username=user.username %}">
            Styles
        </a>
    </div>
    <div class="Tabs__content">
    {% if styles %}
        <ul class='PresentationList__ul'>{% for s in styles %}
            <li class='emphasisbox__parent'>
                <a href="{% url 'styles:edit' user.username s.id %}"
                   class='PresentationList__item emphasisbox__left'>
                    <img src="{% url 'styles:thumb' s.user.username s.id %}" 
                         alt="Thumbnail"
                         width="320px" height="180px"
                         class='PresentationList__thumb'>
                    <div class='PresentationList__title'>
                        <h2>{{ s.title }}</h2>
                    </div>
                </a>
                <div class='PresentationList__actions emphasisbox__actions'>
                    <a class="button small"
                       href="{% url 'styles:edit' s.user.username s.id %}">
                        Edit
                    </a>
                </div>
            </a></li>
        {% endfor %}</ul>
    {% elif is_pro %}
        <h1>Styles are Coming Soon</h1>
        <p>Create a style is the powerful styles editor that powers all
           built in Presenter Club styles.  Create a Style is currently
           in the final stages of a UX redevelopment to make it easy and
           fast to use.</p>
        <p>All Pro users are offered a free concierge style design service.
           If you have not already been contacted about your style,
           don't hesitate to email us at
           <a href='mailto:concierge@presenter.club'>
           concierge@presenter.club</a>.</p>
    {% else %}
        <h1>Give Your Presentations Flair</h1>
        <p>With Presenter Club Pro you can create your own styles; for you,
           your company or your organisation.  Use styles to makes your
           presentations unique and consistent with your brand.</p>
        <p><a href='{% url 'promo:plans' %}'>Learn more about Pro,</a>
           or <a href='{% url 'promo:gopro' %}'>go pro now</a></p>
    {% endif %}
    </div>
</div>
{% endblock content %}

styles/templates/styles/thumb.html
{% comment %}
Presenter Club - Make Great Presentations, Faster
Copyright (C) 2016 Sam Parkinson <sam@sam.today>

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
{% endcomment %}

{% load staticfiles %}
{% load render_bundle from webpack_loader %}

<html>
    <head>
        <link rel="stylesheet" href="{% static 'css/main.css' %}" />
    </head>

    <body>
        <div id="react-container"></div>
        <script>
            window.djangosGift = {{ json_string | safe }};
        </script>
        {% render_bundle 'style_genthumb' 'js' %}
    </body>
</html>